%% Ej 6 TP 4  -  SyS 2017

%// Autor: SR
%// 1- Comparacion entre TF aproximada y analitica de una funcion tri(t/2)
%// 2- Comparacion entre coeficientes de la SG aproximados y analiticos 
%      para una seal cuadrada que tiene un periodo q(t) = caj(t/4)
%// 3- Reconstruccion de la seal cuadrada utilizando los coeficientes
%      calculados.
%// 4- La seal cuadrada entra a un sistema (filtro) y podemos calcular los
%      coeficientes de la SF de la salida evaluando a H en las frecuencias 
%      k/T y luego multiplicando por los Ck de la entrada.

% Necesita la funciones tri, plot_SR, stem_SR y caj

%% 1) TF 
% Probar de cambiar dt, df y el largo del vector f. Analizar los
% resultados.

clear all;clc;close all;

dt = 0.01;
t = -2:dt:2;
x = tri(t/2);

df = 0.01; 
f = -2:df:2;
X = zeros(size(f));

for k=1:length(f)
    X(k) = sum(x.*exp(-1i*2*pi*f(k)*t).*dt);
end

X_anal = 2*sinc(f*2).^2;

figure('units','normalized','outerposition',[0 0 1 1]) % Creo y maximizo figura.

subplot(2,1,1)
plot_SR([f(1) f(end) -0.1 2.1],'','','',20,2,f,abs(X));hold on;
plot_SR([f(1) f(end) -0.1 2.1],'f','abs($X(f)$)',['Espectro de $x(t)$. dt = ' num2str(dt)],20,1,f,abs(X_anal))
legend('Aprox.','Analtico')

subplot(2,1,2)
plot_SR([f(1) f(end) 0 2],'','','',20,2,f,angle(X));hold on;
plot_SR([f(1) f(end) 1.1*min(angle(X)) 1.1*max(angle(X))],'f','angle($X(f)$)','',20,1,f,angle(X_anal))
legend('Aprox.','Analtico')

%% 2) SF:
% Probar de cambiar dt y el "numero de armonicos" K.

clc;

T = 8; 
dt = T/10000; 
t = -0.5*T:dt:0.5*T;

K = 19; ks = -K:K;
q = caj(t/4); c = zeros(1,2*K+1);

for k = ks
    c(K+1+k)=1/T*sum(q.*exp(-1i*2*pi*k*t/T))*dt;
end

c_anal = 1/2*sinc(ks/2);

figure('units','normalized','outerposition',[0 0 1 1]) % Creo y maximizo figura.

subplot(2,1,1)
stem_SR([ks(1) ks(end) -0.1 0.6],'','','',20,2,ks,abs(c));hold on;
stem_SR([ks(1) ks(end) -0.1 0.6],'k','abs($c[k]$)','Coef. de la SF de $x(t)$',20,1,ks,abs(c_anal));
legend('Aprox.','Analtico')

subplot(2,1,2)
stem_SR([ks(1) ks(end) 0 2],'','','',20,2,ks,angle(c));hold on;
stem_SR([ks(1) ks(end) 1.1*min(angle(c)) 1.1*max(angle(c))],'k','angle($c[k])$)','',20,1,ks,angle(c_anal))
legend('Aprox.','Analtico')

%% 3) Reconstruccion
% Ver las diferencias segun los cambios realizados en la seccion anterior.

clc;

y = zeros(size(t));
for k = ks
    y = y + c(k+K+1).*exp(1i*2*pi*k*t/T);
end

figure('units','normalized','outerposition',[0 0 1 1]) % Creo y maximizo figura.

plot_SR([t(1) t(end) -0.5 1.5],'','','',20,2,t,y);hold on;
plot_SR([t(1) t(end) -0.5 1.5],'t','','$q(t)$',20,2,t,q);
legend('q(t) Aprox.','q(t) Analtico')

%% 4) Pase por filtro y salida
% Ver las diferencias segun los cambios realizados en la secciones 
% anteriores.

w = 2*pi*ks/T;
H = (1i*w)./((1i*w).^2 + 2*1i*w + 1);
d = c.*H;
d_anal = c_anal.*H;

y_H = zeros(size(t));

for k = ks
    y_H = y_H + d(k+K+1).*exp(1i*2*pi*k*t/T);
end

figure('units','normalized','outerposition',[0 0 1 1]) % Creo y maximizo figura.

plot_SR([t(1) t(end) -0.5 1.5],'','','',20,2,t,y_H);hold on;
plot_SR([t(1) t(end) -0.5 1.5],'t','','',20,2,t,q);
legend('Salida del sistema aprox. (1 T)','Entrada del sistema (1 T).')
